#include	"StdAfx.h"
#include	"LibFaad2.h"

// 
CLibFaad2::CLibFaad2( VOID)
{
	m_hInstLib = NULL;
	m_lpfncNeAACDecInit = NULL;

}

// 
CLibFaad2::~CLibFaad2()
{
	if( m_hInstLib != NULL)
	{
		FreeLibrary( m_hInstLib);
	}
}



// DLL̏
//   in  : none
//   out : TURE  .. SUCCESS
//         FALSE .. FAILURE
BOOL	CLibFaad2::LoadLibFaad2DLL( VOID)
{
	BOOL	bReturnValue = FALSE;

	m_hInstLib = LoadLibrary( "libfaad2.dll");
	if( m_hInstLib != NULL)
	{	// libfaad2.dll 𔭌
		while( TRUE)
		{
			m_lpfncNeAACDecInit = ( long( NEAACDECAPI *)( NeAACDecHandle, unsigned char *, unsigned long, unsigned long *, unsigned char *))GetProcAddress( m_hInstLib, "NeAACDecInit");
			if( m_lpfncNeAACDecInit == NULL) break;

			m_lpfncNeAACDecOpen = ( NeAACDecHandle( NEAACDECAPI *)(void))GetProcAddress( m_hInstLib, "NeAACDecOpen");
			if( m_lpfncNeAACDecOpen == NULL) break;

			m_lpfncNeAACDecClose = ( void( NEAACDECAPI*)( NeAACDecHandle))GetProcAddress( m_hInstLib, "NeAACDecClose");
			if( m_lpfncNeAACDecClose == NULL) break;

			m_lpfncNeAACDecGetCurrentConfiguration = ( NeAACDecConfigurationPtr( NEAACDECAPI*)( NeAACDecHandle))GetProcAddress( m_hInstLib, "NeAACDecGetCurrentConfiguration");
			if( m_lpfncNeAACDecGetCurrentConfiguration == NULL) break;

			m_lpfncNeAACDecSetConfiguration = ( unsigned char( NEAACDECAPI*)( NeAACDecHandle, NeAACDecConfigurationPtr))GetProcAddress( m_hInstLib, "NeAACDecSetConfiguration");
			if( m_lpfncNeAACDecSetConfiguration == NULL) break;

			m_lpfncNeAACDecDecode = ( void*( NEAACDECAPI*)( NeAACDecHandle, NeAACDecFrameInfo*, unsigned char*, unsigned long))GetProcAddress( m_hInstLib, "NeAACDecDecode");
			if( m_lpfncNeAACDecDecode == NULL) break;

			m_lpfncNeAACDecGetErrorMessage = ( char*( NEAACDECAPI*)(unsigned char))GetProcAddress( m_hInstLib, "NeAACDecGetErrorMessage");
			if( m_lpfncNeAACDecGetErrorMessage == NULL) break;

			bReturnValue = TRUE;
			break;
		}
	}

	return( bReturnValue);
}


// Init the library based on info from the AAC file (ADTS/ADIF)
long	CLibFaad2::NeAACDecInit( NeAACDecHandle hDecoder, unsigned char *buffer, unsigned long buffer_size, unsigned long *samplerate, unsigned char *channels)
{
	return( m_lpfncNeAACDecInit( hDecoder, buffer, buffer_size, samplerate, channels));
}

// 
NeAACDecHandle	CLibFaad2::NeAACDecOpen( void)
{

	return( m_lpfncNeAACDecOpen());
}

// 
void	CLibFaad2::NeAACDecClose( NeAACDecHandle hDecoder)
{
	m_lpfncNeAACDecClose( hDecoder);
}


//
NeAACDecConfigurationPtr	CLibFaad2::NeAACDecGetCurrentConfiguration( NeAACDecHandle hDecoder)
{
	return( m_lpfncNeAACDecGetCurrentConfiguration( hDecoder));
}


//
unsigned char	CLibFaad2::NeAACDecSetConfiguration( NeAACDecHandle hDecoder, NeAACDecConfigurationPtr config)
{
	return( m_lpfncNeAACDecSetConfiguration( hDecoder, config));
}


//
void*	CLibFaad2::NeAACDecDecode( NeAACDecHandle hDecoder, NeAACDecFrameInfo *hInfo, unsigned char *buffer, unsigned long buffer_size)
{
	return( m_lpfncNeAACDecDecode( hDecoder, hInfo, buffer, buffer_size));
}

// 
char*	CLibFaad2::NeAACDecGetErrorMessage( unsigned char errcode)
{
	return( m_lpfncNeAACDecGetErrorMessage( errcode));
}
