#if !defined(AFX_PROGRESSWINDOW_H__F3CF1658_71A6_4FF9_B873_5C699A13F136__INCLUDED_)
#define AFX_PROGRESSWINDOW_H__F3CF1658_71A6_4FF9_B873_5C699A13F136__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ProgressWindow.h : wb_[ t@C
//

#include	"ToWaveParam.h"
#include	"LibFaad2.h"

#pragma		pack( push, wav_header, 1)
typedef struct	// wh
{
	DWORD	dwRiffHeader;				// RIFFwb_
	DWORD	dwFileSize;					// t@CTCY-8
	DWORD	dwWaveHeader;				// WAVEwb_
} STWaveHeader, *LPSTWaveHeader;

typedef struct	// chd
{
	DWORD	dwChunkName;				// `N
	DWORD	dwChunkSize;				// `NTCY
} STCHUNKHEADER, *LPSTCHUNKHEADER;

typedef struct	// fc
{
	DWORD	dwChunkName;				// `N('f'A'm'A't'A' 'Œ)
	DWORD	dwChunkSize;				// `NTCY(16Œ)
	USHORT	nFormatID;					// tH[}bgID(1Œ)
	USHORT	nChannelNum;				// `l
	DWORD	dwSamplingRate;				// TvO[g
	DWORD	dwDataSpeed;				// f[^x
	USHORT	nBlockSize;					// ubNTCY
	USHORT	nBits;						// rbg(16 or 8)
} STFMTCHUNK, *LPSTFMTCHUNK;	// fmt chunk

#pragma		pack( pop, wav_header)

// STDECAACINFO.nStatus
//   lF1ȏ̒l̏ꍇ NeAACDecDecode ̃G[l
typedef enum
{
	eDAISTATUS_NO_ERROR				= 0,	// G[Ȃ
	eDAISTATUS_CHANGE_CHANNEL_NUM	= -1,	// `lς
	eDAISTATUS_FRAME_NEXT			= -2,	// ̃t[ֈڍs
	eDAISTATUS_FRAME_SKIP			= -3,	// t[XLbv
	eDAISTATUS_LASTFRAME_BROKEN		= -4,	// ŏIt[j
	eDAISTATUS_COMPLETE				= -5,	// I

} DAISTATUS;

typedef struct _STDECAACINFO	// dai
{
	UINT64		nTime;
	UINT		nFrameNo;
	UINT		nAdrs;
	INT			nChannelNum;
	DAISTATUS	nStatus;

	_STDECAACINFO*	lpNext;
} STDECAACINFO, *LPSTDECAACINFO;	// Decode AAC Information

typedef enum
{
	eDECODER_VLC = 0,
	eDECODER_LIBFAAD2
} DECODER;


/////////////////////////////////////////////////////////////////////////////
// CProgressWindow _CAO

class CProgressWindow : public CDialog
{
// RXgNV
public:
	CProgressWindow(CWnd* pParent = NULL);   // W̃RXgN^
	~CProgressWindow();

// _CAO f[^
	//{{AFX_DATA(CProgressWindow)
	enum { IDD = IDD_PROGRESS };
	CProgressCtrl	m_pPrgrsTotal;
	CProgressCtrl	m_pPrgrsTarget;
	//}}AFX_DATA


// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CProgressWindow)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g
	//}}AFX_VIRTUAL

public:
	virtual void OnOK();
	virtual void OnCancel();

// Cve[V
protected:

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CProgressWindow)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


private:
	CToWaveParam*	m_pToWaveParam;
	static	UINT	fncExecThread( LPVOID pParam);
	CWinThread*		m_pExecThread;
	LPBYTE			m_lpchBuffer;
	UINT			m_nBufferSize;

	DECODER			n_nDecoder;
	UINT			m_nSampleRate;

	FLOAT			m_fTargetPrgrsBarBase;
	FLOAT			m_fTargetPrgrsBarMax;
	FLOAT			m_fTotalPrgrsBarBase;
	FLOAT			m_fTotalPrgrsBarMax;

	LPSTDECAACINFO	m_lpdaiDecAACInfoRoot;
	LPSTDECAACINFO	m_lpdaiDecAACInfoTail;

	INT				m_nErrorNum;

	STWaveHeader	m_whRiffHeader;
	STFMTCHUNK		m_fcFmtChunk;
	STCHUNKHEADER	m_chDataChunk;

	CLibFaad2*		m_pLibFaad2;

	PROCESS_INFORMATION		m_piProcInfo;

	VOID			fncExecThreadMain( VOID);

	// VLCs
	VOID	RunVLC( LPSTR lpchSrcFileName, LPSTR lpchWavFileName);

	// libfaad2.dllAACfR[hs
	BOOL	RunLibFaad2( LPSTR lpchSrcFileName, LPSTR lpchWavFileName, LPSTR lpchDelayWaveFileName, INT nDelayTime, BOOL bDirectOut);

	// fBClt@C擾AfBCl␳t@C𐶐
	LPSTR	CreateDelayFileName( LPSTR lpchWavFileName, LPINT lpnDelayTime);

	// fBClCWAV𐶐
	VOID	CreateDelayWav( LPSTR lpchWavFileName, LPSTR lpchDelayWaveFileName, INT nDelayTime);

	// t@Cǂݍ
	UINT	WaveReadFile( HANDLE hfHandle, LPBYTE lpchBuffer, UINT nReadSize);

	// t@C
	UINT	WaveWriteFile( HANDLE hfHandle, LPBYTE lpchBuffer, UINT nWriteSize);

	// t@C
	UINT	WaveWriteFile( HANDLE hfHandle, LPSTR lpchText);

	// t@CɉsR[h
	UINT	WaveWriteFileCRLF( HANDLE hfHandle);

	// wavet@C̏o͊
	VOID	FinalizedWaveFile( HANDLE hfHandle);

	// ڍ׃Ot@C̏o
	VOID	CreateLogFile( LPSTR lpchSrcFileName, LPSTR lpchWavFileName, LPSTR lpchDelayWavFileName, INT nDelayTime);

	// fR[h񃊃Xg̉
	VOID	ReleaseDAI( VOID);

public:
	// 
	VOID	SetParam( CToWaveParam* pToWaveParam, CLibFaad2* pLibFaad2);

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B

#endif // !defined(AFX_PROGRESSWINDOW_H__F3CF1658_71A6_4FF9_B873_5C699A13F136__INCLUDED_)
